package com.isartdigital.game.sprites;

import com.isartdigital.utils.game.BoxType;
import com.isartdigital.utils.game.factory.MovieClipAnimFactory;
import com.isartdigital.utils.game.StateGraphic;
import pixi.extras.MovieClip;

	
/**
 * ...
 * @author Cindy Asselin de Beauville
 */
class BackgroundGame extends StateGraphic 
{
	
	/**
	 * instance unique de la classe BackgroundGame
	 */
	private static var instance: BackgroundGame;
	
	/**
	 * Retourne l'instance unique de la classe, et la crée si elle n'existait pas au préalable
	 * @return instance unique
	 */
	public static function getInstance (): BackgroundGame {
		if (instance == null) instance = new BackgroundGame();
		return instance;
	}
	
	/**
	 * constructeur privé pour éviter qu'une instance soit créée directement
	 */
	private function new() 
	{
		super();
		factory = new MovieClipAnimFactory();
		//assetName = "BackgroundGame";
		boxType = BoxType.SIMPLE;
		init();
	}
	
	public function init() {
		start();
		setModeNormal();
	}
	
	override private function setModeNormal():Void {
		setState(DEFAULT_STATE, true);
		untyped anim.animationSpeed = 0.15;
		super.setModeNormal();
	}
	
	
	/**
	 * détruit l'instance unique et met sa référence interne à null
	 */
	override public function destroy (): Void {
		instance = null;
	}

}